/*
 *  Primer brute-force algoritma za desifrovanje md5. Ne obracati previse paznje, algoritam je ostavljen kao primer.
 */

#include <stdlib.h>
#include <string>
#include <cstdlib>
#include <vector>
#include "md5.h"
#include <thread>

using namespace std;

void decrypt(string s, vector<char> &v, vector<char> &tmp, int k, int end)
{
    if(k >= end)
    {
        string decrypted = "";
        
        for(int i = 0; i < k; i++)
            decrypted = decrypted + tmp[i];
 
       // cout << "Testing: " << decrypted << endl;
        
        if(md5(decrypted) == s)
        {
            cout << "Decrypted: " << decrypted << endl;
            exit(EXIT_SUCCESS);
        }
        
        return;
    }
        
    
    for(int i = 0; i < v.size(); i++)
    {
        tmp[k] = v[i];
        decrypt(s, v, tmp, k+1, end);
    }
}

void decrypt_wrap(string s, int mod)
{
     vector<char> v = {'0', '1', '2', '3', '4', '5' ,'6', '7' ,'8', '9' ,'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '!', '?', '#', '-'};
    
     vector<char> tmp(10);
     
     decrypt(s, v, tmp, 0, mod);
}

int main()
{
   
    string s;
    
    cin >> s;
    
    for(int i = 0; i < 10000; i++)
    {
     //   cout << "Testing: " << i << endl;
        if(md5(to_string(i)) == s)
        {
            cout << "Decrypted: " << i << endl;
            return 0;
        }
    }
    
    thread mod1(decrypt_wrap, s, 1);
    thread mod2(decrypt_wrap, s, 2);
    thread mod3(decrypt_wrap, s, 3);
    thread mod4(decrypt_wrap, s, 4);
    thread mod5(decrypt_wrap, s, 5);
    thread mod6(decrypt_wrap, s, 6);
    
    mod1.join();
    mod2.join();
    mod3.join();
    mod4.join();
    mod5.join();
    mod6.join();
    
    return 0;
}
