/*
 * Svaki razlomak oblika p/q se moze zapisati kao zbir egipatskih razlomaka (oblika 1/x + 1/y + ... 1/z) i eventualno jednog celog broja.
 * Algoritam pohlepnom strategijom razbija uneti razlomak na zbir egipatskih razlomaka.
 */

#include <iostream>

using namespace std;

void ispisi_egipatske(unsigned long brojilac, unsigned long imenilac)
{
    if(brojilac == 0 || imenilac == 0)
        return;
    
    if(imenilac % brojilac == 0)
    {
        cout << "1/" << (imenilac / brojilac);
    }
    else if(brojilac > imenilac)
    {
        cout << brojilac/imenilac << " + ";
        ispisi_egipatske(brojilac % imenilac, imenilac);
    }
    else {
        long novi = imenilac / brojilac + 1;
        cout << "1/" << novi << " + ";
        
        ispisi_egipatske(brojilac*novi - imenilac, imenilac * novi);
    }
}

int main()
{
    unsigned long imenilac, brojilac;
    
    cin >> brojilac >> imenilac ;
    cout << brojilac << "/" << imenilac << " = ";
    
    ispisi_egipatske(brojilac, imenilac);
 
    cout << endl;
    
    return 0;
}