/*
 * Algoritam pohlepnom strategijom pokusava da vrati iznos zadatog kusura pomocu sto manjeg broja novcanica. Prvo se unosi broj novcanica, zatim vrednosti novcanica i na kraju vrednost kusura
 */

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void vrati_kusur(vector<int> &novcanice, int kusur)
{
    for(int i = 0; i < novcanice.size(); i++)
    {
        if(kusur == 0)
            return;
        
        int broj_novcanica = kusur / novcanice[i];
        cout << broj_novcanica << " * " << novcanice[i] << endl;
        kusur = kusur - (broj_novcanica * novcanice[i]);
    }
    
    if(kusur != 0)
    {
        cout << "Algoritam nije uspeo da pronadje resenje!" << endl; 
    }
}

int main()
{
    vector<int> novcanice;
    
    int n;
    cin >> n;
    int apoen;
    int kusur;
    
    for(int i = 0; i < n; i++)
    {
        cin >> apoen;
        novcanice.push_back(apoen);
    }
    
    make_heap(novcanice.begin(), novcanice.end(), greater<int>());
    sort_heap(novcanice.begin(), novcanice.end(), greater<int>());
    
    
    cin >> kusur;
    
    vrati_kusur(novcanice, kusur);

    return 0;
}